#include <math.h>

void getRBConGradientEnergyBendingOPT(
  double young,
  double shear,
  double radw,
  double radh,
  double hL0,
  const double *iniMatTanRB,
  const double iniMatNorRB,
  const double *iniRefTanRO,
  const double *iniRefNorRO,
  double rtx,
  const double *rotationAnglesRB,
  double *ex,
  double thetax,
  double *energyGradient)
{
  double t10;
  double t100;
  double t103;
  double t107;
  double t108;
  double t11;
  double t110;
  double t117;
  double t118;
  double t12;
  double t124;
  double t128;
  double t129;
  double t13;
  double t133;
  double t137;
  double t14;
  double t140;
  double t141;
  double t146;
  double t15;
  double t151;
  double t152;
  double t153;
  double t155;
  double t156;
  double t159;
  double t16;
  double t160;
  double t161;
  double t163;
  double t164;
  double t165;
  double t167;
  double t168;
  double t173;
  double t175;
  double t177;
  double t180;
  double t183;
  double t184;
  double t187;
  double t189;
  double t190;
  double t192;
  double t198;
  double t199;
  double t2;
  double t20;
  double t201;
  double t202;
  double t203;
  double t205;
  double t207;
  double t212;
  double t213;
  double t216;
  double t218;
  double t22;
  double t220;
  double t224;
  double t23;
  double t231;
  double t232;
  double t238;
  double t24;
  double t244;
  double t246;
  double t248;
  double t25;
  double t251;
  double t255;
  double t257;
  double t26;
  double t265;
  double t266;
  double t27;
  double t272;
  double t278;
  double t28;
  double t283;
  double t286;
  double t288;
  double t29;
  double t294;
  double t30;
  double t308;
  double t31;
  double t32;
  double t34;
  double t346;
  double t351;
  double t353;
  double t354;
  double t359;
  double t36;
  double t363;
  double t366;
  double t37;
  double t377;
  double t379;
  double t384;
  double t385;
  double t388;
  double t39;
  double t393;
  double t400;
  double t41;
  double t410;
  double t412;
  double t417;
  double t42;
  double t422;
  double t427;
  double t43;
  double t44;
  double t441;
  double t444;
  double t45;
  double t452;
  double t46;
  double t464;
  double t465;
  double t477;
  double t48;
  double t492;
  double t494;
  double t499;
  double t5;
  double t50;
  double t502;
  double t507;
  double t511;
  double t516;
  double t518;
  double t519;
  double t52;
  double t526;
  double t527;
  double t53;
  double t534;
  double t539;
  double t550;
  double t56;
  double t564;
  double t57;
  double t6;
  double t609;
  double t615;
  double t62;
  double t621;
  double t624;
  double t63;
  double t633;
  double t64;
  double t644;
  double t65;
  double t655;
  double t66;
  double t67;
  double t68;
  double t685;
  double t687;
  double t69;
  double t690;
  double t697;
  double t7;
  double t70;
  double t706;
  double t709;
  double t718;
  double t72;
  double t729;
  double t73;
  double t74;
  double t740;
  double t77;
  double t771;
  double t772;
  double t775;
  double t779;
  double t786;
  double t796;
  double t8;
  double t80;
  double t825;
  double t828;
  double t831;
  double t838;
  double t848;
  double t86;
  double t87;
  double t9;
  double t90;
  double t91;
  double t92;
  double t93;
  double t94;
  double t95;
  t2 = radh * radh;
  t8 = rotationAnglesRB[2];
  t5 = cos(t8);
  t12 = rotationAnglesRB[1];
  t6 = cos(t12);
  t7 = t5 * t6;
  t9 = sin(t12);
  t10 = t5 * t9;
  t15 = rotationAnglesRB[0];
  t11 = sin(t15);
  t13 = sin(t8);
  t14 = cos(t15);
  t16 = t10 * t11 - t13 * t14;
  t20 = t10 * t14 + t13 * t11;
  t30 = iniMatTanRB[0];
  t36 = iniMatTanRB[1];
  t39 = iniMatTanRB[2];
  t22 = t7 * t30 + t16 * t36 + t20 * t39;
  t42 = ex[0];
  t23 = t42 * t42;
  t45 = ex[1];
  t24 = t45 * t45;
  t46 = ex[2];
  t25 = t46 * t46;
  t26 = t23 + t24 + t25;
  t27 = sqrt(t26);
  t28 = 0.1e1 / t27;
  t29 = t22 * t28;
  t31 = 0.1e1 * t29 * t42;
  t32 = t13 * t6;
  t34 = t13 * t9;
  t37 = t34 * t11 + t5 * t14;
  t41 = t34 * t14 - t5 * t11;
  t43 = t32 * t30 + t37 * t36 + t41 * t39;
  t44 = t43 * t28;
  t48 = t6 * t11;
  t50 = t6 * t14;
  t52 = -t30 * t9 + t48 * t36 + t50 * t39;
  t53 = t52 * t28;
  t56 = 0.1e1 + t31 + 0.1e1 * t44 * t45 + 0.1e1 * t53 * t46;
  t57 = 0.1e1 / t56;
  t62 = 0.1e1 * t44 * t46 - 0.1e1 * t53 * t45;
  t63 = t57 * t62;
  t64 = t28 * t45;
  t65 = cos(thetax);
  t66 = pow(iniRefTanRO[0], 0.2e1);
  t67 = pow(iniRefTanRO[1], 0.2e1);
  t68 = pow(iniRefTanRO[2], 0.2e1);
  t69 = t66 + t67 + t68;
  t70 = t65 * t69;
  t72 = sin(thetax);
  t73 = t28 * t42;
  t93 = iniRefNorRO[1];
  t74 = t69 * t93;
  t94 = iniRefNorRO[0];
  t77 = t69 * t94;
  t80 = 0.1e1 * t73 * t74 - 0.1e1 * t64 * t77;
  t86 = t28 * t46;
  t100 = iniRefNorRO[2];
  t87 = t69 * t100;
  t90 = 0.1e1 * t73 * t77 + 0.1e1 * t64 * t74 + 0.1e1 * t86 * t87;
  t91 = 0.1e1 - t65;
  t92 = t90 * t91;
  t95 = t70 * t100 + t72 * t80 + 0.1e1 * t86 * t92;
  t103 = 0.1e1 * t86 * t77 - 0.1e1 * t73 * t87;
  t107 = t70 * t93 + t72 * t103 + 0.1e1 * t92 * t64;
  t108 = t107 * t86;
  t110 = 0.1e1 * t64 * t95 - 0.1e1 * t108;
  t117 = 0.1e1 * t53 * t42 - 0.1e1 * t29 * t46;
  t118 = t57 * t117;
  t124 = 0.1e1 * t64 * t87 - 0.1e1 * t74 * t86;
  t128 = t70 * t94 + t72 * t124 + 0.1e1 * t92 * t73;
  t129 = t86 * t128;
  t133 = 0.1e1 * t129 - 0.1e1 * t73 * t95;
  t137 = 0.1e1 * t29 * t45;
  t140 = t137 - 0.1e1 * t44 * t42;
  t141 = t57 * t140;
  t146 = 0.1e1 * t107 * t73 - 0.1e1 * t64 * t128;
  t151 = t56 * t56;
  t152 = 0.1e1 / t151;
  t153 = t152 * t62;
  t155 = t28 / t26;
  t156 = t22 * t155;
  t159 = 0.1e1 * t29;
  t160 = t43 * t155;
  t161 = t45 * t42;
  t163 = 0.1e1 * t160 * t161;
  t164 = t52 * t155;
  t165 = t46 * t42;
  t167 = 0.1e1 * t164 * t165;
  t168 = -0.1e1 * t156 * t23 + t159 - t163 - t167;
  t173 = 0.1e1 * t160 * t165;
  t175 = 0.1e1 * t161 * t164;
  t177 = t57 * (-t173 + t175);
  t180 = t155 * t45;
  t183 = 0.1e1 * t180 * t95 * t42;
  t184 = t155 * t23;
  t187 = t28 * t69;
  t189 = 0.1e1 * t187 * t93;
  t190 = t77 * t42;
  t192 = 0.1e1 * t180 * t190;
  t198 = 0.1e1 * t187 * t94;
  t199 = t74 * t42;
  t201 = 0.1e1 * t180 * t199;
  t202 = t155 * t46;
  t203 = t87 * t42;
  t205 = 0.1e1 * t202 * t203;
  t207 = (-0.1e1 * t184 * t77 + t198 - t201 - t205) * t91;
  t216 = t92 * t202;
  t212 = 0.1e1 * t216 * t42;
  t213 = t72 * (-0.1e1 * t184 * t74 + t189 + t192) + 0.1e1 * t207 * t86 - t212;
  t218 = 0.1e1 * t202 * t107 * t42;
  t220 = 0.1e1 * t202 * t190;
  t224 = 0.1e1 * t187 * t100;
  t231 = 0.1e1 * t92 * t180 * t42;
  t232 = t72 * (-t220 + 0.1e1 * t184 * t87 - t224) + 0.1e1 * t207 * t64 - t231;
  t238 = t152 * t117;
  t244 = 0.1e1 * t53;
  t246 = 0.1e1 * t156 * t165;
  t248 = t57 * (-0.1e1 * t164 * t23 + t244 + t246);
  t251 = t128 * t42;
  t255 = 0.1e1 * t180 * t203;
  t257 = 0.1e1 * t202 * t199;
  t265 = 0.1e1 * t92 * t28;
  t266 = t72 * (-t255 + t257) + 0.1e1 * t207 * t73 - 0.1e1 * t92 * t184 + t265;
  t272 = 0.1e1 * t28 * t95;
  t278 = t152 * t140;
  t283 = 0.1e1 * t156 * t161;
  t286 = 0.1e1 * t44;
  t288 = t57 * (-t283 + 0.1e1 * t160 * t23 - t286);
  t294 = 0.1e1 * t28 * t107;
  t308 = radw * radw;
  t346 = 0.1e1 / hL0;
  t351 = t46 * t45;
  t353 = 0.1e1 * t164 * t351;
  t354 = -t283 - 0.1e1 * t160 * t24 + t286 - t353;
  t359 = 0.1e1 * t160 * t351;
  t363 = t57 * (-t359 + 0.1e1 * t164 * t24 - t244);
  t366 = t155 * t24;
  t377 = 0.1e1 * t202 * t87 * t45;
  t379 = (-t192 - 0.1e1 * t366 * t74 + t189 - t377) * t91;
  t384 = 0.1e1 * t216 * t45;
  t385 = t72 * (-t201 + 0.1e1 * t366 * t77 - t198) + 0.1e1 * t379 * t86 - t384;
  t388 = t107 * t45;
  t393 = 0.1e1 * t202 * t77 * t45;
  t400 = t72 * (-t393 + t255) + 0.1e1 * t379 * t64 - 0.1e1 * t92 * t366 + t265;
  t410 = 0.1e1 * t156 * t351;
  t412 = t57 * (-t175 + t410);
  t417 = 0.1e1 * t202 * t128 * t45;
  t422 = 0.1e1 * t202 * t74 * t45;
  t427 = t72 * (-0.1e1 * t366 * t87 + t224 + t422) + 0.1e1 * t379 * t73 - t231;
  t441 = t57 * (-0.1e1 * t156 * t24 + t159 + t163);
  t444 = t155 * t42;
  t452 = 0.1e1 * t28 * t128;
  t492 = -t246 - t359 - 0.1e1 * t164 * t25 + t244;
  t499 = t57 * (-0.1e1 * t160 * t25 + t286 + t353);
  t502 = t95 * t46;
  t507 = t155 * t25;
  t511 = (-t220 - t422 - 0.1e1 * t507 * t87 + t224) * t91;
  t516 = t72 * (-t257 + t393) + 0.1e1 * t511 * t86 - 0.1e1 * t92 * t507 + t265;
  t527 = t72 * (-0.1e1 * t507 * t77 + t198 + t205) + 0.1e1 * t511 * t64 - t384;
  t539 = t57 * (-t167 + 0.1e1 * t156 * t25 - t159);
  t550 = t72 * (-t377 + 0.1e1 * t507 * t74 - t189) + 0.1e1 * t511 * t73 - t212;
  t564 = t57 * (-t410 + t173);
  t609 = (t20 * t36 - t16 * t39) * t28;
  t615 = (t41 * t36 - t37 * t39) * t28;
  t621 = (t50 * t36 - t48 * t39) * t28;
  t624 = 0.1e1 * t609 * t42 + 0.1e1 * t615 * t45 + 0.1e1 * t621 * t46;
  t633 = t57 * (0.1e1 * t615 * t46 - 0.1e1 * t621 * t45);
  t644 = t57 * (0.1e1 * t621 * t42 - 0.1e1 * t609 * t46);
  t655 = t57 * (0.1e1 * t609 * t45 - 0.1e1 * t615 * t42);
  t685 = t11 * t36;
  t687 = t14 * t39;
  t690 = (-t10 * t30 + t7 * t685 + t7 * t687) * t28;
  t697 = (-t34 * t30 + t32 * t685 + t32 * t687) * t28;
  t706 = (-t6 * t30 - t9 * t11 * t36 - t9 * t14 * t39) * t28;
  t709 = 0.1e1 * t690 * t42 + 0.1e1 * t697 * t45 + 0.1e1 * t706 * t46;
  t718 = t57 * (0.1e1 * t697 * t46 - 0.1e1 * t706 * t45);
  t729 = t57 * (0.1e1 * t706 * t42 - 0.1e1 * t690 * t46);
  t740 = t57 * (0.1e1 * t690 * t45 - 0.1e1 * t697 * t42);
  t771 = -t43;
  t772 = t771 * t28;
  t775 = 0.1e1 * t772 * t42 + t137;
  t779 = t57 * t22;
  t786 = t57 * t771;
  t796 = t57 * (0.1e1 * t772 * t45 - t31);
  t825 = t72 * t69;
  t828 = t90 * t72;
  t831 = -t825 * t100 + t65 * t80 + 0.1e1 * t828 * t86;
  t838 = -t825 * t93 + t65 * t103 + 0.1e1 * t828 * t64;
  t848 = -t94 * t825 + t65 * t124 + 0.1e1 * t828 * t73;
  t464 = young * radw * t2 * radh * M_PI * (0.2e1 * t63 * t110 + 0.2e1 * t118 * t133 + 0.2e1 * t141 * t146);
  t465 = t153 * t110;
  t477 = t238 * t133;
  t494 = t278 * t146;
  t518 = young * t308 * radw * radh * M_PI * (-0.2e1 * t63 * t128 - 0.2e1 * t118 * t107 - 0.2e1 * t141 * t95);
  t519 = t153 * t128;
  t526 = t238 * t107;
  t534 = t278 * t95;
  energyGradient[0] = (0.50e0 * t464 * (-0.2e1 * t465 * t168 + 0.2e1 * t177 * t110 + 0.2e1 * t63 * (-t183 + 0.1e1 * t64 * t213 + t218 - 0.1e1 * t86 * t232) - 0.2e1 * t477 * t168 + 0.2e1 * t248 * t133 + 0.2e1 * t118 * (-0.1e1 * t202 * t251 + 0.1e1 * t86 * t266 + 0.1e1 * t184 * t95 - t272 - 0.1e1 * t73 * t213) - 0.2e1 * t494 * t168 + 0.2e1 * t288 * t146 + 0.2e1 * t141 * (-0.1e1 * t184 * t107 + t294 + 0.1e1 * t73 * t232 + 0.1e1 * t180 * t251 - 0.1e1 * t266 * t64)) + 0.50e0 * t518 * (0.2e1 * t519 * t168 - 0.2e1 * t177 * t128 - 0.2e1 * t63 * t266 + 0.2e1 * t526 * t168 - 0.2e1 * t248 * t107 - 0.2e1 * t118 * t232 + 0.2e1 * t534 * t168 - 0.2e1 * t288 * t95 - 0.2e1 * t141 * t213)) * t346 / 0.2e1;
  energyGradient[1] = (0.50e0 * t464 * (-0.2e1 * t465 * t354 + 0.2e1 * t363 * t110 + 0.2e1 * t63 * (-0.1e1 * t366 * t95 + t272 + 0.1e1 * t64 * t385 + 0.1e1 * t202 * t388 - 0.1e1 * t86 * t400) - 0.2e1 * t477 * t354 + 0.2e1 * t412 * t133 + 0.2e1 * t118 * (-t417 + 0.1e1 * t86 * t427 + t183 - 0.1e1 * t73 * t385) - 0.2e1 * t494 * t354 + 0.2e1 * t441 * t146 + 0.2e1 * t141 * (-0.1e1 * t444 * t388 + 0.1e1 * t73 * t400 + 0.1e1 * t366 * t128 - t452 - 0.1e1 * t64 * t427)) + 0.50e0 * t518 * (0.2e1 * t519 * t354 - 0.2e1 * t363 * t128 - 0.2e1 * t63 * t427 + 0.2e1 * t526 * t354 - 0.2e1 * t412 * t107 - 0.2e1 * t118 * t400 + 0.2e1 * t534 * t354 - 0.2e1 * t441 * t95 - 0.2e1 * t141 * t385)) * t346 / 0.2e1;
  energyGradient[2] = (0.50e0 * t464 * (-0.2e1 * t465 * t492 + 0.2e1 * t499 * t110 + 0.2e1 * t63 * (-0.1e1 * t180 * t502 + 0.1e1 * t64 * t516 + 0.1e1 * t507 * t107 - t294 - 0.1e1 * t86 * t527) - 0.2e1 * t477 * t492 + 0.2e1 * t539 * t133 + 0.2e1 * t118 * (-0.1e1 * t507 * t128 + t452 + 0.1e1 * t86 * t550 + 0.1e1 * t444 * t502 - 0.1e1 * t73 * t516) - 0.2e1 * t494 * t492 + 0.2e1 * t564 * t146 + 0.2e1 * t141 * (-t218 + 0.1e1 * t73 * t527 + t417 - 0.1e1 * t64 * t550)) + 0.50e0 * t518 * (0.2e1 * t519 * t492 - 0.2e1 * t499 * t128 - 0.2e1 * t63 * t550 + 0.2e1 * t526 * t492 - 0.2e1 * t539 * t107 - 0.2e1 * t118 * t527 + 0.2e1 * t534 * t492 - 0.2e1 * t564 * t95 - 0.2e1 * t516 * t141)) * t346 / 0.2e1;
  energyGradient[3] = (0.50e0 * t464 * (-0.2e1 * t465 * t624 + 0.2e1 * t633 * t110 - 0.2e1 * t477 * t624 + 0.2e1 * t644 * t133 - 0.2e1 * t494 * t624 + 0.2e1 * t655 * t146) + 0.50e0 * t518 * (0.2e1 * t519 * t624 - 0.2e1 * t633 * t128 + 0.2e1 * t526 * t624 - 0.2e1 * t644 * t107 + 0.2e1 * t534 * t624 - 0.2e1 * t655 * t95)) * t346 / 0.2e1;
  energyGradient[4] = (0.50e0 * t464 * (-0.2e1 * t465 * t709 + 0.2e1 * t718 * t110 - 0.2e1 * t477 * t709 + 0.2e1 * t729 * t133 - 0.2e1 * t494 * t709 + 0.2e1 * t740 * t146) + 0.50e0 * t518 * (0.2e1 * t519 * t709 - 0.2e1 * t718 * t128 + 0.2e1 * t526 * t709 - 0.2e1 * t729 * t107 + 0.2e1 * t534 * t709 - 0.2e1 * t740 * t95)) * t346 / 0.2e1;
  energyGradient[5] = (0.50e0 * t464 * (-0.2e1 * t465 * t775 + 0.2e1 * t779 * t86 * t110 - 0.2e1 * t477 * t775 - 0.2e1 * t786 * t86 * t133 - 0.2e1 * t494 * t775 + 0.2e1 * t146 * t796) + 0.50e0 * t518 * (0.2e1 * t519 * t775 - 0.2e1 * t779 * t129 + 0.2e1 * t526 * t775 + 0.2e1 * t786 * t108 + 0.2e1 * t534 * t775 - 0.2e1 * t796 * t95)) * t346 / 0.2e1;
  energyGradient[6] = (0.50e0 * t464 * (0.2e1 * t63 * (0.1e1 * t64 * t831 - 0.1e1 * t86 * t838) + 0.2e1 * t118 * (0.1e1 * t86 * t848 - 0.1e1 * t73 * t831) + 0.2e1 * t141 * (0.1e1 * t73 * t838 - 0.1e1 * t64 * t848)) + 0.50e0 * t518 * (-0.2e1 * t63 * t848 - 0.2e1 * t118 * t838 - 0.2e1 * t141 * t831)) * t346 / 0.2e1;
}
